<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<!-- <title>Trustonic Tests: 00300_GP_workspace_xRAM</title> -->
<img align="right" width="300" src="TrustonicLogo.jpg">
</br>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.7.2 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul class="tablist">
      <li><a href="main.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<h1>00300_GP_workspace_xRAM<br/>
<small>
[<a class="el" href="group___t_e_s_t___l_i_m_i_t_a_t_i_o_n_s.html">Limitations</a>]</small>
</h1>  </div>
</div>
<div class="contents">

<p><b>Involved Components and their required Functionality</b>  
<a href="#_details">More...</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group_____g_p__workspace__x_r_a_m.html#ga0fbaad89a2d85fbffa82aa862b2b4afe">TestCase_GC00001_xRAM_available</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group_____g_p__workspace__x_r_a_m.html#ga4783f1931f2a42bb1b4136f8fd9f2fd5">TestCase_GC00004_xRAM_sessions_available</a> ()</td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p><b>Involved Components and their required Functionality</b> </p>
<ol type="1">
<li>ClientLib<ol type="a">
<li>Can connect to daemon</li>
<li>Can reserve memory for connection</li>
</ol>
</li>
<li>McDriverDaemon<ol type="a">
<li>Daemon running</li>
<li>Daemon socket accessible by TLC</li>
<li>mcOpenDevice()</li>
</ol>
</li>
<li>Trusted Application TlTestIntegrationTest<ol type="a">
<li>8 + 4 Trusted Application copied to Android on Test device in registrymcRegistry as :<ul>
<li>12kB 1 | fe7cf500b5c65edbb1bdab6dcba5f0d7.tabin</li>
<li>12kB 2 | 27d9038f3bea5c65aae9443021a1fd92.tabin</li>
<li>12kB 3 | c8e116f308de558ebe2d1220fb9cd394.tabin</li>
<li>12kB 4 | a841fb02ce325a838a3a41005aa2d169.tabin</li>
<li>16kB | e6cf131ee1b35325a24afb673215822a.tabin</li>
<li>32kB | c3e29bbddd3354638e9afc6a2679faff.tabin</li>
<li>64kB | 477ae7dd7d6c52da9f555b879495389b.tabin</li>
<li>128kB | d89db6058e3d588da7504e6c610921d0.tabin</li>
<li>256kB | 84da16f1082d5e128d5989dfd308fafc.tabin</li>
<li>512kB | 63c0d7b52ee75e77b533e35cce8685a0.tabin</li>
<li>1MB | 82caf2d7014c5fec9385e9eff3e3f4d2.tabin</li>
<li>2MB | 22cfa2a161b159f98fa68a683b4c7299.tabin</li>
</ul>
</li>
</ol>
</li>
</ol>
<ul>
<li>Each TA has the same code except a special header which is generated for each TA. This header contains arrays which will increase the size of the :<ul>
<li>code section</li>
<li>data section</li>
</ul>
</li>
</ul>
<p><b>Meaning of this test group</b><br/>
 We try to get an estimation of the available workspace size and sessions. There is a first set of 9 TAs with memory size going from 12 kB to 2MB. It is possible to open for each TA up to 16 instances, it is possible to test a workspace with a maximum size of 32 MB. The minimal workspace size could be a few kB.</p>
<p>There is a second set of 4 TAs with a memory size of 12 KB (this means that a TA uses 2 pages from the DDR pool and 1 page from the L2 pool.) It is possible to open for each TA up to 16 instances, and we have 4 TAs. This means we could open up to 64 sessions, which is our maximum hardcoded session number. As each TAs will only take 2p DDR and 1p L2, we could retrieve the maximum number of session available with a workspace of only 128 kB.</p>
<p>TODO-[2015-06-05]-[microv01] It is possible to extend this test to retreive the size of L2 pool available part. this should be based on Kinibi version number, and known hardcoded formula which describe the different pools. TODO-[2015-06-05]-[microv01] It is possible to extend this test to retreive the size of IRAM pool. TODO-[2015-06-05]-[microv01] We could implement "Kinibi syscall" to retrieve the size and available size of each pool. </p>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga0fbaad89a2d85fbffa82aa862b2b4afe"></a><!-- doxytag: member="00300_GP_workspace_xRAM.cpp::TestCase_GC00001_xRAM_available" ref="ga0fbaad89a2d85fbffa82aa862b2b4afe" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">TestCase_GC00001_xRAM_available </td>
          <td>(</td>
          <td class="paramname">&#160;)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="user"><dt><b>Trusted Applications dependencies:</b></dt><dd>none </dd></dl>
<dl class="user"><dt><b>Pre Conditions:</b></dt><dd>setup() initializes the context </dd></dl>
<dl class="user"><dt><b>Focus:</b></dt><dd>Open as many as possible GP TA sessions, (instances) for each TA inside the array g_uuid_tab (TAs from 12 kB to 2 MB), beginning with big size TAs first. This will give the workspace available size. </dd></dl>
<dl class="user"><dt><b>Test Steps:</b></dt><dd>Open as many as possible GP TA sessions for each TA of a different size. Ensure that basic error on InvokeCommand is handled correctly. Note the internal test function will fail on allocation error, but this is ignored. The maximum number of each TA instance is returned The total is also printed. </dd></dl>
<dl class="user"><dt><b>Verification:</b></dt><dd>InvokeCommand has to return specified error code </dd></dl>
<dl class="user"><dt><b>Post Conditions:</b></dt><dd>teardown() closes session and finalizes the context </dd></dl>
<dl class="user"><dt><b>Manual Execution:</b></dt><dd>No </dd></dl>
<dl class="user"><dt><b>Trustonic Test Suite Testcase:</b></dt><dd><a href="group___tts.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Final Device Testcase:</b></dt><dd><a href="group___final___device.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Extensive Testcase:</b></dt><dd><a href="group___extensive.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Basic Testcase:</b></dt><dd><a href="group___basic.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Quick Testcase:</b></dt><dd>No </dd></dl>
<dl class="user"><dt><b>Test ID:</b></dt><dd>Limitations.00300_GP_workspace_xRAM.GC00001_xRAM_available </dd></dl>

</div>
</div>
<a class="anchor" id="ga4783f1931f2a42bb1b4136f8fd9f2fd5"></a><!-- doxytag: member="00300_GP_workspace_xRAM.cpp::TestCase_GC00004_xRAM_sessions_available" ref="ga4783f1931f2a42bb1b4136f8fd9f2fd5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">TestCase_GC00004_xRAM_sessions_available </td>
          <td>(</td>
          <td class="paramname">&#160;)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="user"><dt><b>Trusted Applications dependencies:</b></dt><dd>none </dd></dl>
<dl class="user"><dt><b>Pre Conditions:</b></dt><dd>setup() initializes the context </dd></dl>
<dl class="user"><dt><b>Focus:</b></dt><dd>Open as many as possible GP TA sessions, (instances) for each TA inside the array g_uuid_ta_12k_tab (TAs of 12 kB). This will give the maximum number of session available. </dd></dl>
<dl class="user"><dt><b>Test Steps:</b></dt><dd>Open as many as possible GP TA sessions for each TA. Ensure that basic error on InvokeCommand is handled correctly. Note the internal test function will fail on allocation error, but this is ignored. The maximum number of each TA instance is returned The total is also printed. </dd></dl>
<dl class="user"><dt><b>Verification:</b></dt><dd>InvokeCommand has to return specified error code </dd></dl>
<dl class="user"><dt><b>Post Conditions:</b></dt><dd>teardown() closes session and finalizes the context </dd></dl>
<dl class="user"><dt><b>Manual Execution:</b></dt><dd>No </dd></dl>
<dl class="user"><dt><b>Trustonic Test Suite Testcase:</b></dt><dd><a href="group___tts.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Final Device Testcase:</b></dt><dd><a href="group___final___device.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Extensive Testcase:</b></dt><dd><a href="group___extensive.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Basic Testcase:</b></dt><dd><a href="group___basic.html">Yes</a>  </dd></dl>
<dl class="user"><dt><b>Quick Testcase:</b></dt><dd>No </dd></dl>
<dl class="user"><dt><b>Test ID:</b></dt><dd>Limitations.00300_GP_workspace_xRAM.GC00004_xRAM_sessions_available </dd></dl>

</div>
</div>
</div>
        <br><br>
        <hr>
        <small><em>Copyright (c) 2013-2015 TRUSTONIC LIMITED - TRUSTONIC CONFIDENTIAL</em></small>
    </body>
</html>
